diff --git a/sys/dev/usb/controller/xhci_dbc.c b/sys/dev/usb/controller/xhci_dbc.c
new file mode 100644
index 000000000000..72c40d60628b
--- /dev/null
+++ b/sys/dev/usb/controller/xhci_dbc.c
@@ -0,0 +1,1429 @@
+/*-
+ * SPDX-License-Identifier: BSD-2-Clause
+ *
+ * Copyright (c) 2019-2024 Hiroki Sato <hrs@FreeBSD.org>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ */
+#include <sys/param.h>
+#include <sys/condvar.h>
+#include <sys/systm.h>	/* getenv_quad */
+
+#ifdef _KERNEL
+# define assert(x)
+# include <sys/bus.h>
+# include <sys/cons.h>
+# include <sys/kdb.h>
+# include <sys/tty.h>
+# include <sys/reboot.h>
+# include <sys/sbuf.h>
+# include <sys/sysctl.h>
+# include <vm/vm.h>
+# include <vm/vm_param.h>
+# include <vm/pmap.h>
+# include <dev/usb/usb.h>
+# include <dev/usb/usbdi.h>
+# include <dev/usb/usb_core.h>
+# include <dev/usb/usb_busdma.h>
+# include <dev/usb/usb_process.h>
+# include <dev/usb/usb_transfer.h>
+# include <dev/usb/usb_device.h>
+# include <dev/usb/usb_controller.h>
+# include <dev/usb/usb_bus.h>
+# include <dev/usb/controller/xhci.h>
+#else
+# include <assert.h>
+# include <bootstrap.h>
+# include <efi.h>
+# include <efilib.h>
+# include <dev/usb/controller/xhci_private.h>
+#endif
+
+#include <dev/usb/controller/xhcireg.h>
+#include <dev/usb/controller/xhci_dbc.h>
+#include <dev/usb/controller/xhci_dbc_private.h>
+
+#ifndef _KERNEL
+#include "xhci_dbc_cons.h"
+#include "xhci_dbc_dma.h"
+#endif
+
+/* XXX: this should be removed */
+static void flush_range(void *, uint32_t);
+
+#if 0
+static bool xhci_debug_running(struct xhci_debug_softc *);
+#endif
+static bool xhci_debug_update_regbit(struct xhci_debug_softc *, int, int, int,
+    bool);
+static bool xhci_debug_set_regbit(struct xhci_debug_softc *, int, int, int);
+static bool xhci_debug_reset_regbit(struct xhci_debug_softc *, int, int, int);
+static bool xhci_debug_wait_connection(struct xhci_debug_softc *, uint32_t);
+
+static void xhci_debug_ring_init(struct xhci_debug_softc *,
+    struct xhci_debug_ring *, int, uint32_t);
+static void xhci_debug_init_ep(struct xhci_endp_ctx64 *, uint64_t, uint32_t,
+    uint64_t);
+
+static void xhci_debug_softc_fixup(struct xhci_debug_softc *);
+static void xhci_debug_init_strings(struct xhci_debug_softc *, uint32_t *);
+
+static void xhci_debug_ring_doorbell(struct xhci_debug_softc *, uint32_t);
+static void xhci_debug_show_ring(struct xhci_debug_ring *, const char *);
+static void xhci_debug_show_ring0(struct xhci_debug_ring *, const char *);
+
+static int trb_tx_enqueue(struct xhci_debug_ring *);
+static int trb_rx_enqueue(struct xhci_debug_ring *);
+#if 0
+static struct xhci_trb *trb_lookup(struct xhci_debug_ring *, uint64_t, int *);
+#endif
+static void trb_push(struct xhci_debug_ring *, uint64_t, uint64_t);
+
+/* XXX */
+static void
+flush_range(void *ptr, uint32_t bytes)
+{
+#ifdef _KERNEL
+	/* amd64 only */
+	pmap_flush_cache_range((vm_offset_t)(uintptr_t)ptr,
+	    (vm_offset_t)((uintptr_t)ptr + bytes));
+#else
+	uint32_t i;
+	const uint32_t clshft = 6;
+	const uint32_t clsize = (1UL << clshft);
+	const uint32_t clmask = clsize - 1;
+	uint32_t lines = (bytes >> clshft);
+	lines += (bytes & clmask) != 0;
+
+	if (bytes == 0)
+		return;
+
+#define	CLFLUSH(ptr) \
+	__asm volatile("clflush %0" : "+m"(*(volatile char *)ptr))
+
+	for (i = 0; i < lines; i++)
+		CLFLUSH((void *)((uint64_t)ptr + (i * clsize)));
+#undef	CLFLUSH
+#endif
+}
+
+#define	STRSTATE(x)	[x] = #x
+static const char *strstate[] = {
+	STRSTATE(XHCI_DCPORT_ST_OFF),
+	STRSTATE(XHCI_DCPORT_ST_DISCONNECTED),
+	STRSTATE(XHCI_DCPORT_ST_DISABLED),
+	STRSTATE(XHCI_DCPORT_ST_RESETTING),
+	STRSTATE(XHCI_DCPORT_ST_ENABLED),
+	STRSTATE(XHCI_DCPORT_ST_CONFIGURED)
+};
+
+void
+udb_dump_info(struct xhci_debug_softc *sc)
+{
+	xhci_debug_event_dequeue(sc);
+
+	xhci_debug_update_state(sc);
+	printf("=============\n");
+	printf("    ctrl: 0x%x stat: 0x%x psc: 0x%x\n",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL),
+	    _XREAD4(sc, dbc, XHCI_DCST),
+	    _XREAD4(sc, dbc, XHCI_DCPORTSC));
+	printf("      DbC Enable = %s\t",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_DCE ? "YES" : "NO");
+	printf("      DbC Running = %s\n",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_DCR ? "YES" : "NO");
+
+	printf("      Link State Event Enable = %s\t",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_LSE ? "YES" : "NO");
+	printf("      Halt OUT TR = %s\n",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_HOT ? "YES" : "NO");
+
+	printf("      Halt IN TR = %s\t",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_HIT ? "YES" : "NO");
+	printf("      DbC Run Change = %s\n",
+	    _XREAD4(sc, dbc, XHCI_DCCTRL) & XHCI_DCCTRL_DRC ? "YES" : "NO");
+
+	printf("      DbC CCS = %s\t",
+	    _XREAD4(sc, dbc, XHCI_DCPORTSC) & XHCI_DCPORTSC_CCS ? "YES" : "NO");
+	printf("      DbC PED = %s\n",
+	    _XREAD4(sc, dbc, XHCI_DCPORTSC) & XHCI_DCPORTSC_PED ? "YES" : "NO");
+
+	printf("      DbC Port = %d\n",
+	    (uint8_t)XHCI_DCST_PORT_GET(_XREAD4(sc, dbc, XHCI_DCST)));
+
+	printf("    id: 0x%x\t", _XREAD4(sc, dbc, XHCI_DCID));
+	printf("    erstsz: %u, erstba: 0x%lx\n",
+	    _XREAD4(sc, dbc, XHCI_DCERSTSZ),
+	    _XREAD44LH(sc, dbc, XHCI_DCERSTBA));
+
+	printf("    erdp: 0x%lx, cp: 0x%lx\t",
+	    _XREAD44LH(sc, dbc, XHCI_DCERDP),
+	    _XREAD44LH(sc, dbc, XHCI_DCCP));
+	printf("    ddi1: 0x%x, ddi2: 0x%x\n",
+	    _XREAD4(sc, dbc, XHCI_DCDDI1),
+	    _XREAD4(sc, dbc, XHCI_DCDDI2));
+
+	printf("    erstba == sc->udb_erst_paddr: %d",
+	    _XREAD44LH(sc, dbc, XHCI_DCERSTBA) == sc->udb_erst_paddr);
+	printf("    erdp == erst[0].qwEvrsTablePtr: %d",
+	    _XREAD44LH(sc, dbc, XHCI_DCERDP) == sc->udb_erst[0].qwEvrsTablePtr);
+	printf("    cp == sc->udb_ctx_paddr: %d\n",
+	    _XREAD44LH(sc, dbc, XHCI_DCCP) == sc->udb_ctx_paddr);
+
+#ifndef _KERNEL
+	/* Loader console structure */
+	printf("=============\n");
+	printf("cons->c_flags = %x\n", sc->sc_cons->c_flags);
+#endif
+	printf("=============\n");
+	/* Update er->enq */
+	printf("ering ready = %s\n",
+	    xhci_debug_event_ready(sc) ? "YES" : "NO");
+	xhci_debug_show_ring0(&sc->udb_ering, "ering");
+	xhci_debug_show_ring0(&sc->udb_iring, "iring");
+	xhci_debug_show_ring0(&sc->udb_oring, "oring");
+	printf("=============\n");
+	printf("sc->dma_allocated = %d, ", sc->dma_allocated);
+	printf("sc->sc_init = %d\n", sc->sc_init);
+
+	printf("sc->sc_state = %s(%02x)\n", strstate[sc->sc_state],
+	    sc->sc_state);
+	printf("=============\n");
+	printf("DbC Commands:\n");
+	printf(" udb_send xxx: Send 'xxx'\n");
+	printf(" udb_recv: Recv'\n");
+	printf(" udb_probe: Probe and initialize DbC\n");
+	printf("=============\n");
+}
+
+#if 0
+static bool
+xhci_debug_running(struct xhci_debug_softc *sc)
+{
+	if (sc == NULL)
+		goto error;
+	if (sc->sc_init == false)
+		goto error;
+
+	xhci_debug_update_state(sc);
+	/* Reinitialize if possible */
+	if (sc->sc_state != XHCI_DCPORT_ST_CONFIGURED) {
+		xhci_debug_enable(sc);
+		xhci_debug_event_dequeue(sc);
+		xhci_debug_update_state(sc);
+	}
+	return (true);
+error:
+	DEBUG_PRINTF("%s: false\n", __func__);
+	return (false);
+}
+#endif
+
+void
+xhci_debug_update_state(struct xhci_debug_softc *sc)
+{
+	uint32_t ctrl;
+	uint32_t portsc;
+	uint32_t sc_state_old;
+
+	ctrl = _XREAD4(sc, dbc, XHCI_DCCTRL);
+	portsc = _XREAD4(sc, dbc, XHCI_DCPORTSC);
+	sc_state_old = sc->sc_state;
+	sc->sc_state = XHCI_DCSTATUS(ctrl, portsc);
+	if (sc->sc_state != sc_state_old)
+		DEBUG_PRINTF("state: %s -> %s\n",
+		    strstate[sc->sc_state], strstate[sc_state_old]);
+}
+
+static bool
+xhci_debug_update_regbit(struct xhci_debug_softc *sc, int reg, int bit,
+    int timeout, bool reset)
+{
+	uint32_t temp;
+	int expected;
+
+	timeout *= 10;	/* ms */
+	temp = le32toh(_XREAD4(sc, dbc, reg));
+	if (reset)
+		temp &= ~bit;
+	else
+		temp |= bit;
+	_XWRITE4(sc, dbc, reg, htole32(temp));
+	expected = (reset) ? 0 : bit;
+	while ((le32toh(_XREAD4(sc, dbc, reg)) & bit) != expected &&
+	    timeout != 0) {
+		delay(100);
+		timeout--;
+	}
+	return (timeout > 0);
+}
+static bool
+xhci_debug_set_regbit(struct xhci_debug_softc *sc, int reg, int bit,
+    int timeout)
+{
+
+	return (xhci_debug_update_regbit(sc, reg, bit, timeout, false));
+}
+static bool
+xhci_debug_reset_regbit(struct xhci_debug_softc *sc, int reg, int bit,
+    int timeout)
+{
+
+	return (xhci_debug_update_regbit(sc, reg, bit, timeout, true));
+}
+
+bool
+xhci_debug_enable(struct xhci_debug_softc *sc)
+{
+	bool ret;
+
+	xhci_debug_softc_fixup(sc);
+	xhci_debug_update_state(sc);
+	ret = true;
+	if (sc->sc_state == XHCI_DCPORT_ST_OFF) {
+		ret = xhci_debug_set_regbit(sc, XHCI_DCCTRL, XHCI_DCCTRL_DCE,
+		    1);
+		xhci_debug_update_state(sc);
+		if (ret == false)
+			DEBUG_PRINTF("%s: setting XHCI_DCCTRL_DCE failed\n",
+			    __func__);
+	}
+	/* If success, check the cable. */
+	return ((ret == true) ? (xhci_debug_wait_connection(sc, 1)) : ret);
+}
+
+static bool
+xhci_debug_wait_connection(struct xhci_debug_softc *sc, uint32_t timeout)
+{
+	bool ret;
+
+	xhci_debug_update_state(sc);
+	if (sc->sc_state == XHCI_DCPORT_ST_DISCONNECTED) {
+		ret = xhci_debug_set_regbit(sc, XHCI_DCPORTSC,
+		    XHCI_DCPORTSC_PED, 1000);	/* XXX: 1 was not enough */
+		xhci_debug_update_state(sc);
+		if (ret == false) {
+			DEBUG_PRINTF("%s: setting XHCI_DCPORTSC_PED failed\n",
+			    __func__);
+			return (ret); 
+		}
+	}
+	DEBUG_PRINTF("%s: Wait DCR\n", __func__);
+	timeout = 10000;
+	xhci_debug_update_state(sc);
+	while (sc->sc_state != XHCI_DCPORT_ST_CONFIGURED) {
+		DEBUG_PRINTF("Insert a debug cable: PR=%d, PLS=%d, DCR=0\n",
+		    ((_XREAD4(sc, dbc, XHCI_DCPORTSC) & XHCI_PS_PR) != 0),
+		    XHCI_PS_PLS_GET(_XREAD4(sc, dbc, XHCI_DCPORTSC)));
+		delay(500);
+		if (timeout-- == 0) {
+			DEBUG_PRINTF("Insert a debug cable: timed out\n");
+			break;
+		}
+		xhci_debug_update_state(sc);
+	}
+	if (timeout == 0)
+		return (false);
+
+	DEBUG_PRINTF("Debug Cable Inserted: PR=%d, PLS=%d, DCR=1\n",
+	    ((_XREAD4(sc, dbc, XHCI_DCPORTSC) & XHCI_PS_PR) != 0),
+	    XHCI_PS_PLS_GET(_XREAD4(sc, dbc, XHCI_DCPORTSC)));
+	return (true);
+}
+
+void
+xhci_debug_disable(struct xhci_debug_softc *sc)
+{
+	bool ret;
+
+	xhci_debug_reset_regbit(sc, XHCI_DCPORTSC, XHCI_DCPORTSC_PED, 0);
+	ret = xhci_debug_reset_regbit(sc, XHCI_DCCTRL, XHCI_DCCTRL_DCE, 1000);
+	if (ret == false)
+		DEBUG_PRINTF("%s: clearing XHCI_DCCTRL_DCE failed\n", __func__);
+	xhci_debug_update_state(sc);
+}
+
+int
+xhci_debug_init_ring(struct xhci_debug_softc *sc)
+{
+	uint64_t erdp, out, in;
+	uint32_t temp;
+
+	if (sc->sc_dbc_off == 0) {
+		DEBUG_PRINTF("%s: register is empty\n", __func__);
+		return (-1);
+	}
+	/* Create an event ring. */
+	xhci_debug_ring_init(sc, &sc->udb_ering, 0, XHCI_DCDB_INVAL);
+	erdp = sc->udb_ering.paddr;
+	memset(sc->udb_erst, 0, sizeof(*sc->udb_erst));
+	sc->udb_erst->qwEvrsTablePtr = htole64(erdp);
+	sc->udb_erst->dwEvrsTableSize = htole32(UDB_TRB_RING_LEN);
+	DEBUG_PRINTF("%s: ERDP=0x%016llx\n", __func__, (unsigned long long)erdp);
+
+	/* Create an output ring. */
+	xhci_debug_ring_init(sc, &sc->udb_oring, 1, XHCI_DCDB_OUT);
+	out = sc->udb_oring.paddr;
+
+	/* Create an input ring. */
+	xhci_debug_ring_init(sc, &sc->udb_iring, 1, XHCI_DCDB_IN);
+	in = sc->udb_iring.paddr;
+
+	/* Initialize DbC context. */
+	memset(sc->udb_ctx, 0, sizeof(*sc->udb_ctx));
+	xhci_debug_init_strings(sc, sc->udb_ctx->info);
+
+	/* Initialize endpoints. */ 
+	temp = _XREAD4(sc, dbc, XHCI_DCCTRL);
+	xhci_debug_init_ep(&sc->udb_ctx->ep_out,
+	    (uint64_t)XHCI_DCCTRL_MBS_GET(le32toh(temp)), EP_BULK_OUT, out);
+	xhci_debug_init_ep(&sc->udb_ctx->ep_in,
+	    (uint64_t)XHCI_DCCTRL_MBS_GET(le32toh(temp)), EP_BULK_IN, in);
+
+	/* Configure register values. */
+	_XWRITE4(sc, dbc, XHCI_DCERSTSZ, htole32(1));
+	_XWRITE44LH(sc, dbc, XHCI_DCERSTBA, htole64(sc->udb_erst_paddr));
+	_XWRITE44LH(sc, dbc, XHCI_DCERDP, htole64(erdp));
+	_XWRITE44LH(sc, dbc, XHCI_DCCP, htole64(sc->udb_ctx_paddr));
+	_XWRITE4(sc, dbc, XHCI_DCDDI1, htole32((DC_VENDOR   << 16) | DC_PROTOCOL));
+	_XWRITE4(sc, dbc, XHCI_DCDDI2, htole32((DC_REVISION << 16) | DC_PRODUCT));
+	flush_range(sc->udb_ctx, sizeof(*sc->udb_ctx));
+	flush_range(sc->udb_erst, sizeof(*sc->udb_erst));
+	flush_range(sc->udb_ering.trb, UDB_TRB_RING_BYTES);
+	flush_range(sc->udb_oring.trb, UDB_TRB_RING_BYTES);
+	flush_range(sc->udb_iring.trb, UDB_TRB_RING_BYTES);
+	flush_range(sc->udb_oring.work.buf, UDB_WORK_RING_BYTES);
+	flush_range(sc->udb_iring.work.buf, UDB_WORK_RING_BYTES);
+
+	return (0);
+}
+
+int
+xhci_debug_probe(struct xhci_debug_softc *sc)
+{
+	uint32_t hccp1;
+	uint32_t eec;
+	uint32_t eecp;
+
+	if (sc == NULL)
+		return (0);
+#ifndef	_KERNEL
+	xhci_debug_pci_mmio_init(sc);
+#endif
+	hccp1 = _XREAD4(sc, capa, XHCI_HCSPARAMS0);
+
+	if (XHCI_HCS0_XECP(hccp1) == 0)
+		goto notfound;
+
+	eec = -1;	/* XXX */
+	for (eecp = XHCI_HCS0_XECP(hccp1) << 2;
+	     eecp != 0 && XHCI_XECP_NEXT(eec) != 0;
+	     eecp += XHCI_XECP_NEXT(eec) << 2) {
+		eec = _XREAD4(sc, capa, eecp);
+
+		if (XHCI_XECP_ID(eec) != XHCI_ID_USB_DEBUG) {
+#if 0
+			DEBUG_PRINTF("%s: looking for %02x\n",
+			    __func__, XHCI_XECP_ID(eec));
+#endif
+			continue;
+		}
+	}
+	if (XHCI_XECP_ID(eec) != XHCI_ID_USB_DEBUG)
+		goto notfound;
+	DEBUG_PRINTF("%s: DBC_ID was found at %08x\n", __func__, eecp);
+	sc->sc_dbc_off = eecp;
+	return (1);
+
+notfound:
+	DEBUG_PRINTF("%s: DBC_ID was not found\n", __func__);
+	return (0);
+}
+
+/*
+ * The hw.usb.xhci.dbc mibs are used to pass physical addresses
+ * from the loader to the kernel.  This function simply relies on
+ * the direct mapping at this moment and works only on the platforms
+ * supporting it.
+ */
+static void
+xhci_debug_softc_fixup(struct xhci_debug_softc *sc)
+{
+	if (sc->sc_fixup_done)
+		return;
+#if _KERNEL
+	quad_t xhci_dbc_iring_work_addr;
+	quad_t xhci_dbc_iring_work_len;
+	quad_t xhci_dbc_oring_work_addr;
+	quad_t xhci_dbc_oring_work_len;
+	quad_t xhci_dbc_softc_addr;
+	quad_t xhci_dbc_softc_len;
+	char buf[256];
+	quad_t addr, len;
+	struct trb_addrs {
+		const char *key;
+		struct xhci_debug_ring *ringp;
+	} parray[] = {
+		{ "hw.usb.xhci.dbc.ering", &sc->udb_ering },
+		{ "hw.usb.xhci.dbc.oring", &sc->udb_oring },
+		{ "hw.usb.xhci.dbc.iring", &sc->udb_iring },
+		{ NULL, NULL }
+	};
+	struct trb_addrs *p;
+
+	KASSERT(PMAP_HAS_DMAP, ("direct-map required"));
+
+	getenv_quad("hw.usb.xhci.dbc.softc.paddr",
+	    &xhci_dbc_softc_addr);
+	getenv_quad("hw.usb.xhci.dbc.softc.len",
+	    &xhci_dbc_softc_len);
+	/* XXX: pmap_map() on amd64 uses only start address. */
+	sc->sc_udb = (struct xhci_debug_softc *)
+	    pmap_map(NULL, (vm_paddr_t)xhci_dbc_softc_addr, 0, 0);
+
+	for (p = &parray[0]; p->key != NULL; p++) {
+
+		snprintf(buf, sizeof(buf), "%s.paddr", p->key);
+		buf[sizeof(buf) - 1] = '\0';
+		getenv_quad(buf, &addr);
+		p->ringp->paddr = (uintptr_t)addr;
+		p->ringp->trb =
+		    (struct xhci_trb *)pmap_map(NULL, p->ringp->paddr, 0, 0);
+
+		/* XXX not used right now */
+		snprintf(buf, sizeof(buf), "%s.len", p->key);
+		buf[sizeof(buf) - 1] = '\0';
+		getenv_quad(buf, &len);
+	}
+
+	getenv_quad("hw.usb.xhci.dbc.iring.work.paddr",
+	    &xhci_dbc_iring_work_addr);
+	getenv_quad("hw.usb.xhci.dbc.iring.work.len",
+	    &xhci_dbc_iring_work_len);
+	/* VA for work ring */
+	/* XXX: pmap_map() on amd64 uses only start address. */
+	sc->udb_iring.work.paddr = (uintptr_t)
+	    pmap_map(NULL, (vm_paddr_t)xhci_dbc_iring_work_addr, 0, 0);
+	sc->udb_iring.work.buf = (char *)
+	    pmap_map(NULL, (vm_paddr_t)xhci_dbc_iring_work_addr, 0, 0);
+
+	getenv_quad("hw.usb.xhci.dbc.oring.work.paddr",
+	    &xhci_dbc_oring_work_addr);
+	getenv_quad("hw.usb.xhci.dbc.oring.work.len",
+	    &xhci_dbc_oring_work_len);
+	/* VA for work ring */
+	/* XXX: pmap_map() on amd64 uses only start address. */
+	sc->udb_oring.work.paddr = (uintptr_t)
+	    pmap_map(NULL, (vm_paddr_t)xhci_dbc_oring_work_addr, 0, 0);
+	sc->udb_oring.work.buf = (char *)
+	    pmap_map(NULL, (vm_paddr_t)xhci_dbc_oring_work_addr, 0, 0);
+
+	sc->udb_ering.enq = sc->sc_udb->udb_ering.enq;
+	sc->udb_ering.deq = sc->sc_udb->udb_ering.deq;
+	sc->udb_ering.cyc = sc->sc_udb->udb_ering.cyc;
+	sc->udb_ering.doorbell = sc->sc_udb->udb_ering.doorbell;
+
+	sc->udb_iring.enq = sc->sc_udb->udb_iring.enq;
+	sc->udb_iring.deq = sc->sc_udb->udb_iring.deq;
+	sc->udb_iring.cyc = sc->sc_udb->udb_iring.cyc;
+	sc->udb_iring.doorbell = sc->sc_udb->udb_iring.doorbell;
+	sc->udb_iring.work.enq = sc->sc_udb->udb_iring.work.enq;
+	sc->udb_iring.work.deq = sc->sc_udb->udb_iring.work.deq;
+
+	sc->udb_oring.enq = sc->sc_udb->udb_oring.enq;
+	sc->udb_oring.deq = sc->sc_udb->udb_oring.deq;
+	sc->udb_oring.cyc = sc->sc_udb->udb_oring.cyc;
+	sc->udb_oring.doorbell = sc->sc_udb->udb_oring.doorbell;
+	sc->udb_oring.work.enq = sc->sc_udb->udb_oring.work.enq;
+	sc->udb_oring.work.deq = sc->sc_udb->udb_oring.work.deq;
+
+	sc->dma_allocated = sc->sc_udb->dma_allocated;
+	sc->sc_init = sc->sc_udb->sc_init;
+
+	/* XXX: DMA mappings must be configured... */
+#if 0
+	{
+		/* incomplete core fragment */
+
+		struct usb_page_cache *pc;
+		struct usb_page *pg;
+		int ret;
+
+		pc = &sc->udb_ering.ring_pc;
+		pg = &sc->udb_ering.ring_pg;
+
+		pc->tag_parent = sc->sc_xhci->sc_bus.dma_parent_tag;
+		if (usb_pc_dmamap_create(pc, UDB_TRB_RING_BYTES) != 0)
+			device_printf(sc->sc_xhci->sc_bus.parent,
+			    "usb_pc_dmamap_create() failed\n");
+		pc->buffer = sc->udb_ering.trb;
+		pc->page_start = pg;
+		if (usb_pc_load_mem(pc, UDB_TRB_RING_BYTES, 1) != 0)
+			device_printf(sc->sc_xhci->sc_bus.parent,
+			    "usb_pc_load_mem() failed\n");
+	}
+#endif
+#endif
+	sc->sc_fixup_done = true;
+}
+
+static void
+xhci_debug_ring_init(struct xhci_debug_softc *sc,
+    struct xhci_debug_ring *ring, int producer, uint32_t doorbell)
+{
+	memset(ring->trb, 0, UDB_TRB_RING_BYTES);
+	memset(ring->work.buf, 0, UDB_WORK_RING_BYTES);
+
+	ring->enq = 0;
+	ring->deq = 0;
+	ring->cyc = 1;
+	ring->doorbell = doorbell;
+	ring->work.enq = 0;
+	ring->work.deq = 0;
+
+	/* Place a link TRB at the tail if producer == 1. */
+	if (producer) {
+		struct xhci_trb *trb = &ring->trb[UDB_TRB_RING_LAST];
+
+		assert(htole32(XHCI_TRB_3_TYPE_SET(XHCI_TRB_TYPE_LINK) | XHCI_TRB_3_TC_BIT) == (XHCI_TRB_3_TYPE_SET(XHCI_TRB_TYPE_LINK) | XHCI_TRB_3_TC_BIT));
+
+		/* Fields for link TRBs (section 6.4.4.1) */
+		*trb = (struct xhci_trb){
+		    .qwTrb0 = htole64(ring->paddr),
+		    .dwTrb3 = htole32(
+			XHCI_TRB_3_TYPE_SET(XHCI_TRB_TYPE_LINK) |
+			XHCI_TRB_3_TC_BIT
+		    )
+		};
+	}
+}
+
+struct usb_strdesc {
+	uint8_t bLength;
+	uint8_t bDescriptorType;
+	uint8_t chars[62];	/* UTF-16LE */
+};
+#define USB_DESC_TYPE_STRING	3
+
+/* Initialize the DbC info with USB string descriptor addresses. */
+void
+xhci_debug_init_strings(struct xhci_debug_softc *sc, uint32_t *info)
+{
+	struct usb_strdesc udb_strdesc[] = {
+		{
+		  .bLength = 2 + 4,
+		  .bDescriptorType = USB_DESC_TYPE_STRING,
+		  .chars = { 9, 0, 4, 0 },	/* 0x0409 = English */
+		},
+		{
+		  .bLength = 2 + 36,
+		  .bDescriptorType = USB_DESC_TYPE_STRING,
+		  .chars = {
+		    'F', 0, 'r', 0, 'e', 0, 'e', 0, 'B', 0, 'S', 0, 'D', 0,
+		    ' ', 0,
+		    'F', 0, 'o', 0, 'u', 0, 'n', 0, 'd', 0, 'a', 0, 't', 0,
+		    'i', 0, 'o', 0, 'n', 0,
+		  }
+		},
+		{
+		  .bLength = 2 + 50,
+		  .bDescriptorType = USB_DESC_TYPE_STRING,
+		  .chars = {
+		    'F', 0, 'r', 0, 'e', 0, 'e', 0, 'B', 0, 'S', 0, 'D', 0,
+		    ' ', 0,
+		    'U', 0, 'S', 0, 'B', 0, ' ', 0, 'D', 0, 'b', 0, 'C', 0,
+		    '.', 0, 'G', 0, 'P', 0, ' ', 0, 'D', 0, 'e', 0, 'v', 0,
+		    'i', 0, 'c', 0, 'e', 0,
+		  }
+		},
+		{
+		  .bLength = 2 + 2,
+		  .bDescriptorType = USB_DESC_TYPE_STRING,
+		  .chars = { '0', 0 }
+		}
+	};
+	uint64_t *sda;
+
+	/* udb_str is 1 page buffer longer than sizeof(udb_strdesc) */
+	memcpy(sc->udb_str, udb_strdesc, sizeof(udb_strdesc));
+
+	sda = (uint64_t *)(void *)&info[0];
+	sda[0] = sc->udb_str_paddr;
+	sda[1] = sda[0] + 64;
+	sda[2] = sda[0] + 64 + 64;
+	sda[3] = sda[0] + 64 + 64 + 64;
+	info[8] = (4 << 24) | (52 << 16) | (38 << 8) | 6;
+}
+
+static void
+xhci_debug_ring_doorbell(struct xhci_debug_softc *sc, uint32_t target)
+{
+	uint32_t doorbell;
+
+	/* The other bits in DCDB are RsvdP. */
+	/* XXX: the spec has contradiction between Figure 7-9 and Table 7-18. */
+	doorbell = _XREAD4(sc, dbc, XHCI_DCDB) & ~XHCI_DCDB_MASK;
+
+	DEBUG_V_PRINTF("%s: doorbell = %04x\n", __func__, doorbell);
+	DEBUG_V_PRINTF("%s: doorbell = %04x (le32toh)\n", __func__,
+	    le32toh(doorbell));
+	DEBUG_V_PRINTF("%s: target = %04x\n", __func__, target);
+
+	doorbell |= target;
+
+	DEBUG_V_PRINTF("%s: doorbell = %04x (updated)\n", __func__, doorbell);
+	DEBUG_V_PRINTF("%s: doorbell = %04x (updated, le32toh)\n", __func__,
+	    le32toh(doorbell));
+	DEBUG_PRINTF("%s: doorbell = %04x\n", __func__, doorbell);
+	_XWRITE4(sc, dbc, XHCI_DCDB, doorbell);
+}
+
+ssize_t
+xhci_debug_bulk_transfer(struct xhci_debug_softc *sc,
+    struct xhci_debug_ring *ring)
+{
+	uint32_t temp;
+	int error;
+
+	/* XXX: running status check? */
+	xhci_debug_update_state(sc);
+
+	/* configure-exit */
+	temp = _XREAD4(sc, dbc, XHCI_DCCTRL);
+	if (XHCI_DCCTRL_DRC_GET(le32toh(temp)) != 0)
+		_XWRITE4(sc, dbc, XHCI_DCCTRL, temp);
+
+	xhci_debug_event_dequeue(sc);
+	xhci_debug_update_state(sc);
+
+	if (XHCI_DEBUG_RING_FULL(ring))	/* TRB queue is full */
+		return (-1);
+
+	error = (ring->doorbell == XHCI_DCDB_IN)
+	    ? trb_rx_enqueue(ring)
+	    : trb_tx_enqueue(ring);
+
+	if (error == 0)
+		xhci_debug_ring_doorbell(sc, ring->doorbell);
+	xhci_debug_update_state(sc);
+
+	return (1);
+}
+
+static void
+xhci_debug_show_ring0(struct xhci_debug_ring *ring, const char *label)
+{
+	printf("%s: deq=%d, enq=%d(%llu), w.deq=%u, w.enq=%u(%llu), paddr=0x%016llx, w.paddr=0x%016llx\n",
+	    label, ring->deq, ring->enq, UDB_TRB_RING_LAST,
+	    ring->work.deq, ring->work.enq, UDB_WORK_RING_LAST,
+	    (unsigned long long)ring->paddr,
+	    (unsigned long long)ring->work.paddr);
+}
+
+static void
+xhci_debug_show_ring(struct xhci_debug_ring *ring, const char *label)
+{
+
+	DEBUG_PRINTF("%s: deq=%d, enq=%d(%llu), w.deq=%u, w.enq=%u(%llu), paddr=0x%016llx, w.paddr=0x%016llx\n",
+	    label, ring->deq, ring->enq, UDB_TRB_RING_LAST,
+	    ring->work.deq, ring->work.enq, UDB_WORK_RING_LAST,
+	    (unsigned long long)ring->paddr,
+	    (unsigned long long)ring->work.paddr);
+}
+
+/*
+ * Initializes the endpoint as specified in sections 7.6.3.2 and 7.6.9.2.
+ * Each endpoint is Bulk, so the MaxPStreams, LSA, HID, CErr, FE,
+ * Interval, Mult, and Max ESIT Payload fields are all 0.   
+ *
+ * Max packet size: 1024
+ * Max burst size: debug mbs (from db_reg->ctrl register)
+ * EP type: 2 for OUT bulk, 6 for IN bulk   
+ * TR dequeue ptr: physical base address of transfer ring
+ * Avg TRB length: software defined (see 4.14.1.1 for suggested defaults, 3kB)
+ */
+static void
+xhci_debug_init_ep(struct xhci_endp_ctx64 *ep64, uint64_t mbs,
+    uint32_t type, uint64_t ring_paddr)
+{
+	struct xhci_endp_ctx *ep;
+
+	if (ep64 == NULL)
+		return;
+	ep = &ep64->ctx;
+	memset(ep64, 0, sizeof(*ep64));
+
+	ep->dwEpCtx1 = htole32(
+	    XHCI_EPCTX_1_MAXP_SIZE_SET(1024) |
+	    XHCI_EPCTX_1_MAXB_SET((uint32_t)mbs) |
+	    XHCI_EPCTX_1_EPTYPE_SET(type));
+	ep->qwEpCtx2 = htole64(
+	    (ring_paddr & XHCI_EPCTX_2_TR_DQ_PTR_MASK) |
+	    XHCI_EPCTX_2_DCS_SET(1));
+	ep->dwEpCtx4 = htole32(
+	    XHCI_EPCTX_4_AVG_TRB_LEN_SET(1024 * 3));
+}
+
+bool
+xhci_debug_event_ready(struct xhci_debug_softc *sc)
+{
+	struct xhci_debug_ring *er = &sc->udb_ering;
+	struct xhci_trb *event = &er->trb[er->deq];
+	uint32_t dwTrb3;
+	uint32_t cyc;
+	uint32_t deq;
+
+	/* XXX: Should DCST be used to check the event queue? */
+
+	cyc = er->cyc;
+	deq = er->deq;
+	LFENCE();
+	dwTrb3 = le32toh(event->dwTrb3);
+
+	while ((dwTrb3 & XHCI_TRB_3_CYCLE_BIT) == cyc) {
+		cyc = (deq == UDB_TRB_RING_LAST)
+		    ? cyc ^ 1
+		    : cyc;
+		deq = (deq + 1) & UDB_TRB_RING_OFFSET_MASK;
+		event = &er->trb[deq];
+		LFENCE();
+		dwTrb3 = le32toh(event->dwTrb3);
+	}
+	if (er->deq < deq)
+		er->enq = deq;
+	else if (er->deq > deq)
+		er->enq = deq + (UDB_TRB_RING_LAST - er->deq);
+
+	return ((dwTrb3 & XHCI_TRB_3_CYCLE_BIT) == er->cyc);
+}
+
+void
+xhci_debug_event_dequeue(struct xhci_debug_softc *sc)
+{
+	struct xhci_debug_ring *er = &sc->udb_ering;
+	struct xhci_debug_ring *ir = &sc->udb_iring;
+	struct xhci_debug_ring *or = &sc->udb_oring;
+	struct xhci_trb *event = &er->trb[er->deq];
+	struct xhci_trb *trb;
+	uint64_t erdp;
+	uint32_t temp;
+	uint64_t qwTrb0;
+	uint32_t dwTrb3;
+	uint32_t dwTrb2;
+	uint32_t ret;
+	uint32_t len;
+
+	sc->sc_polling_count++;
+
+	LFENCE();
+	qwTrb0 = le64toh(event->qwTrb0);
+	dwTrb2 = le32toh(event->dwTrb2);
+	dwTrb3 = le32toh(event->dwTrb3);
+	while ((dwTrb3 & XHCI_TRB_3_CYCLE_BIT) == er->cyc) {
+		switch (XHCI_TRB_3_TYPE_GET(dwTrb3)) {
+		case XHCI_TRB_EVENT_TRANSFER:
+			/* EP ID is an index of context. */
+			DEBUG_PRINTF("%s: event transfer TRB: index=%d, epno=%d\n",
+			    __func__,
+			    XHCI_TRB_3_SLOT_GET(dwTrb3),
+			    XHCI_TRB_3_EP_GET(dwTrb3));
+
+			ret = XHCI_TRB_2_ERROR_GET(dwTrb2);
+
+			if (ret != XHCI_TRB_ERROR_SUCCESS &&
+			    ret != XHCI_TRB_ERROR_SHORT_PKT) {
+				DEBUG_PRINTF("transfer error (%u)", ret);
+				switch (ret) {
+				case XHCI_TRB_ERROR_RING_UNDERRUN:
+					DEBUG_PRINTF(": RING_UNDERRUN\n");
+					break;
+				case XHCI_TRB_ERROR_RING_OVERRUN:
+					DEBUG_PRINTF(": RING_OVERRUN\n");
+					break;
+				case XHCI_TRB_ERROR_TRB:
+					DEBUG_PRINTF(": TRB\n");
+					break;
+				case XHCI_TRB_ERROR_STALL:
+					DEBUG_PRINTF(": STALL\n");
+					break;
+				default:
+					DEBUG_PRINTF("\n");
+				}
+        		}
+			if (XHCI_TRB_3_EP_GET(dwTrb3) == XHCI_DC_EPID_OUT ||
+			    XHCI_TRB_3_EP_GET(dwTrb3) == XHCI_DC_EPID_OUT_INTEL) {
+				if ((dwTrb3 & XHCI_TRB_3_ISP_BIT) != 0) {
+					/* Event Data */
+					break;
+				}
+				/* Update the dequeue pointer using ER. */
+				xhci_debug_show_ring(or, "oring0");
+// XXX: (qwTrb0 & MASK) >> 4 (16 bytes)
+				or->deq = qwTrb0 - (uint64_t)or->paddr;
+				or->deq /= sizeof(struct xhci_trb);
+				trb = &or->trb[or->deq];
+
+				xhci_debug_show_ring(or, "oring1");
+			} else if (XHCI_TRB_3_EP_GET(dwTrb3) == XHCI_DC_EPID_IN ||
+			    XHCI_TRB_3_EP_GET(dwTrb3) == XHCI_DC_EPID_IN_INTEL) {
+				if ((dwTrb3 & XHCI_TRB_3_ISP_BIT) != 0) {
+					/* Event Data */
+					break;
+				}
+				/* Update the dequeue pointer using ER. */
+				xhci_debug_show_ring(ir, "iring0");
+				ir->deq = qwTrb0 - (uint64_t)ir->paddr;
+				ir->deq /= sizeof(struct xhci_trb);
+				trb = &ir->trb[ir->deq];
+
+				/* An event not associated with iring */
+				if (!XHCI_DEBUG_RING_EMPTY(ir))
+					ir->deq = (ir->deq + 1) &
+					    UDB_TRB_RING_OFFSET_MASK;
+
+				assert(trb->dwTrb2 == le32toh(trb->dwTrb2));
+				len = XHCI_TRB_2_BYTES_GET(le32toh(trb->dwTrb2))
+				    - XHCI_TRB_2_BYTES_GET(dwTrb2);
+				DEBUG_PRINTF("recv transfer length = %u - %u = %u\n",
+				    XHCI_TRB_2_BYTES_GET(le32toh(trb->dwTrb2)),
+				    XHCI_TRB_2_BYTES_GET(dwTrb2),
+				    len);
+				DEBUG_PRINTF("addr: paddr=%lu, qwTrb0=%lu,"
+				    "masked addr=%lu, "
+				    "calculated index=%lu\n",
+				    (uint64_t)ir->paddr,
+				    qwTrb0,
+				    (qwTrb0 & (uint64_t)UDB_TRB_RING_MASK) >> 4,
+				    ((qwTrb0 - (uint64_t)ir->paddr) / sizeof(struct xhci_trb))
+				);
+
+				/* Advance the enq of work q */
+				flush_range(&sc->udb_iring.work.buf[ir->work.enq], len);
+				ir->work.enq += len;
+
+				xhci_debug_show_ring(ir, "iring1");
+			} else {
+				DEBUG_PRINTF("%s: unknown EP ID=%d\n", __func__,
+				    XHCI_TRB_3_EP_GET(dwTrb3));
+			}
+			break;
+		case XHCI_TRB_EVENT_PORT_STS_CHANGE:
+			temp = _XREAD4(sc, dbc, XHCI_DCPORTSC);
+			assert(temp == le32toh(temp));
+			if (XHCI_DCPORTSC_CSC_GET(le32toh(temp))) {
+				DEBUG_PRINTF("cable status changed\n");
+				assert(temp == le32toh(temp));
+				if (XHCI_DCPORTSC_CCS_GET(le32toh(temp)) == 0)
+					DEBUG_PRINTF("cable unplugged\n");
+			}
+			assert(XHCI_DCPORTSC_ACK_MASK == htole32(XHCI_DCPORTSC_ACK_MASK));
+			_XWRITE4(sc, dbc, XHCI_DCPORTSC,
+			    temp & htole32(XHCI_DCPORTSC_ACK_MASK));
+			break;
+		default:
+			break;
+		}
+		er->cyc = (er->deq == UDB_TRB_RING_LAST)
+		    ? er->cyc ^ 1
+		    : er->cyc;
+		er->deq = (er->deq + 1) & UDB_TRB_RING_OFFSET_MASK;
+		event = &er->trb[er->deq];
+		LFENCE();
+		qwTrb0 = le64toh(event->qwTrb0);
+		dwTrb2 = le32toh(event->dwTrb2);
+		dwTrb3 = le32toh(event->dwTrb3);
+	}
+	erdp = _XREAD44LH(sc, dbc, XHCI_DCERDP);
+	erdp &= ~UDB_TRB_RING_MASK;
+	erdp |= er->deq * sizeof(struct xhci_trb);
+	_XWRITE44LH(sc, dbc, XHCI_DCERDP, erdp);
+}
+
+static int
+trb_rx_enqueue(struct xhci_debug_ring *ring)
+{
+	struct xhci_debug_work_ring *work;
+	uint64_t addr;
+	uint64_t len;
+
+	if (ring == NULL)
+		return (-1);
+
+	work = &ring->work;
+	if (work == NULL)
+		return (-1);
+	/* Skip if there are pending TRB */
+	if (!XHCI_DEBUG_RING_EMPTY(ring))
+		return (-1);
+	/* Skip if there are received data */
+	if (!UDB_WORK_RING_EMPTY(ring))
+		return (-1);
+
+	addr = work->paddr + work->enq;
+	len = (work->enq < work->deq) ? work->deq : UDB_WORK_RING_LEN;
+	len -= work->enq;
+	trb_push(ring, addr, len);
+	return (0);
+}
+
+static int
+trb_tx_enqueue(struct xhci_debug_ring *ring)
+{
+	struct xhci_debug_work_ring *work;
+	uint64_t addr;
+	uint64_t len;
+
+	if (ring == NULL)
+		return (-1);
+
+	work = &ring->work;
+	if (work == NULL)
+		return (-1);
+
+	if (UDB_WORK_RING_EMPTY(ring)) {
+		trb_push(ring, 0, 0);
+	} else if (work->deq < work->enq) {
+		addr = work->paddr + work->deq;
+		len = work->enq - work->deq;
+		trb_push(ring, addr, len);
+
+		work->deq = work->enq;
+	} else {
+		addr = work->paddr + work->deq;
+		len = UDB_WORK_RING_LEN - work->deq;
+		trb_push(ring, addr, len);
+
+		work->deq = 0;
+
+		if (0 < work->enq && !XHCI_DEBUG_RING_FULL(ring)) {
+			addr = work->paddr;
+			len = work->enq;
+			trb_push(ring, addr, len);
+			work->deq = work->enq;
+		}
+	}
+	return (0);
+}
+
+#if 0
+static struct xhci_trb *
+trb_lookup(struct xhci_debug_ring *ring, uint64_t addr, int *idx)
+{
+	int i;
+
+	*idx = 0;
+	for (i = 0; i < UDB_TRB_RING_LEN; i++)
+		if (addr == ring->paddr + sizeof(*ring->trb) * i) {
+			*idx = i;
+			break;
+		}
+
+	return ((i == UDB_TRB_RING_LEN) ? NULL : &ring->trb[i]);
+}
+#endif
+
+static void
+trb_push(struct xhci_debug_ring *ring, uint64_t addr, uint64_t len)
+{
+	struct xhci_trb trb;
+
+	if (ring->enq == UDB_TRB_RING_LAST) {
+		/*
+		 * If the ring->enq points the tail of the ring,
+		 * put a link TRB there and wrap-around the enq pointer.
+		 */
+		struct xhci_trb *link = &ring->trb[ring->enq];
+
+		link->dwTrb3 &= ~htole32(XHCI_TRB_3_CYCLE_BIT);
+		link->dwTrb3 |= htole32(ring->cyc);
+
+		ring->enq = 0;
+		ring->cyc ^= 1;
+	}
+	/* Clearing the structure is required. */
+	memset(&trb, 0, sizeof(trb));
+	trb = (struct xhci_trb){
+	    .qwTrb0 = htole64(addr),
+	    .dwTrb2 = htole32(
+		XHCI_TRB_2_BYTES_SET(le32toh(trb.dwTrb2) | (uint32_t)len)
+	    ),
+	    .dwTrb3 = htole32(
+		XHCI_TRB_3_TYPE_SET(XHCI_TRB_TYPE_NORMAL)
+		| ring->cyc | XHCI_TRB_3_IOC_BIT
+	    )
+	};
+	memcpy(&ring->trb[ring->enq], &trb, sizeof(ring->trb[0]));
+	flush_range(&ring->trb[ring->enq], sizeof(ring->trb[0]));
+	xhci_debug_show_ring(ring, "push0");
+	ring->enq = (ring->enq + 1 ) & UDB_TRB_RING_OFFSET_MASK;
+	xhci_debug_show_ring(ring, "push1");
+}
+
+int
+work_dequeue(struct xhci_debug_ring *ring)
+{
+	struct xhci_debug_work_ring *work;
+	int c;
+
+	c = -1;
+ 	work = &ring->work;
+	if (!UDB_WORK_RING_EMPTY(ring)) {
+		xhci_debug_show_ring(ring, "work_dequeue0");
+		c = (int)work->buf[work->deq];
+		work->deq = (work->deq + 1) & UDB_WORK_RING_OFFSET_MASK;
+		DEBUG_PRINTF("%s: [%c]\n", __func__, (char)c);
+		xhci_debug_show_ring(ring, "work_dequeue1");
+	}
+	return (c);
+}
+
+int64_t
+work_enqueue(struct xhci_debug_ring *ring, const char *buf, int64_t len)
+{
+	struct xhci_debug_work_ring *work;
+	int64_t i = 0;
+	uint32_t start;
+	uint32_t end = 0;
+
+	work = &ring->work;
+	start = work->enq;
+	while (!UDB_WORK_RING_FULL(ring) && i < len) {
+		work->buf[work->enq++] = buf[i++];
+		work->enq &= UDB_WORK_RING_OFFSET_MASK;
+	}
+	end = work->enq;
+
+	if (end > start)
+		flush_range(&work->buf[start], end - start);
+	else if (i > 0) {
+		flush_range(&work->buf[start], UDB_WORK_RING_LEN - start);
+		flush_range(&work->buf[0], end);
+	}
+	return (i);
+}
+
+#ifdef _KERNEL
+/* udbcons is the device node for USB DbC. */
+
+#define	UDBCONS_NAME	"udbcons"
+
+struct udbcons_priv;
+static int udbcons_ischar(struct udbcons_priv *);
+typedef void udbcons_putc_t(struct udbcons_priv *, int);
+typedef int udbcons_getc_t(struct udbcons_priv *);
+struct udbcons_ops {
+	udbcons_putc_t	*putc;
+	udbcons_getc_t	*getc;
+};
+struct udbcons_priv {
+	device_t			dev;	/* XHCI */
+	struct xhci_softc		*xhci;
+	const struct udbcons_ops	*ops;
+	struct callout			callout;
+	struct tty			*tp;
+	bool				opened;
+	int				polltime;
+	int				alt_break_state;
+};
+
+static struct udbcons_priv udbcons0;
+
+static SYSCTL_NODE(_hw_usb, OID_AUTO, dbc, CTLFLAG_RW | CTLFLAG_MPSAFE, 0,
+    "USB XHCI DbC");
+
+static int
+sysctl_udb_info(SYSCTL_HANDLER_ARGS)
+{
+	int error;
+	struct xhci_debug_softc *sc;
+	struct sbuf *sb;
+
+	if (udbcons0.xhci == NULL)
+		return (-1);
+	if ((sc = udbcons0.xhci->sc_udbc) == NULL)
+		return (-1);
+
+#define	DUMP_RING(label, ring) do { \
+	sbuf_printf(sb, \
+	    "  %s: deq=%d, enq=%d(%llu), w.deq=%u, w.enq=%u(%llu), paddr=0x%016llx, w.paddr=0x%016llx\n", \
+	    #label, (ring)->deq, (ring)->enq, UDB_TRB_RING_LAST, \
+	    (ring)->work.deq, (ring)->work.enq, UDB_WORK_RING_LAST, \
+	    (unsigned long long)(ring)->paddr, \
+	    (unsigned long long)(ring)->work.paddr); \
+	} while (0)
+
+	sb = sbuf_new_auto();
+	sbuf_printf(sb, "\n");
+	sbuf_printf(sb, "  ering ready = %s\n",
+	    xhci_debug_event_ready(sc) ? "YES" : "NO");
+	DUMP_RING(ering, &sc->udb_ering); 
+	DUMP_RING(iring, &sc->udb_iring); 
+	DUMP_RING(oring, &sc->udb_oring); 
+	sbuf_printf(sb, "  sc->dma_allocated = %d,\n", sc->dma_allocated);
+	sbuf_printf(sb, "  sc->sc_init = %d\n", sc->sc_init);
+	sbuf_printf(sb, "  sc->sc_state = %s(%02x)\n", strstate[sc->sc_state],
+	    sc->sc_state);
+	sbuf_printf(sb, "  sc->sc_polling_count = %lu\n", sc->sc_polling_count);
+
+	if (sbuf_finish(sb) != 0)
+		return (-1);
+	error = sysctl_handle_opaque(oidp, sbuf_data(sb), sbuf_len(sb), req);
+	sbuf_delete(sb);
+
+	return (error);
+}
+SYSCTL_PROC(_hw_usb_dbc, OID_AUTO, info,
+    CTLTYPE_STRING | CTLFLAG_RD | CTLFLAG_MPSAFE,
+    NULL, 0, sysctl_udb_info, "A", "DbC info"); 
+
+static int
+udbcons_getc(struct udbcons_priv *cons)
+{
+	struct xhci_softc *sc;
+	struct xhci_debug_softc *sc_udbc;
+	struct xhci_debug_ring *iring;
+
+	if (cons == NULL)
+		 return (-1);
+	if ((sc = cons->xhci) == NULL)
+		 return (-1);
+	if (sc->sc_dbc_off == 0)
+		 return (-1);
+	if ((sc_udbc = sc->sc_udbc) == NULL)
+		return (-1);
+
+	iring = &sc_udbc->udb_iring;
+	/* Use udbcons_ischar() to receive data */
+	return (udbcons_ischar(cons) ? work_dequeue(iring) : -1);
+}
+static int
+udbcons_ischar(struct udbcons_priv *cons)
+{
+	struct xhci_softc *sc;
+	struct xhci_debug_softc *sc_udbc;
+	struct xhci_debug_ring *iring;
+
+	if (cons == NULL)
+		 return (0);
+	if ((sc = cons->xhci) == NULL)
+		 return (0);
+	if (sc->sc_dbc_off == 0)
+		return (0);
+	if ((sc_udbc = sc->sc_udbc) == NULL)
+		return (0);
+
+	iring = &sc_udbc->udb_iring;
+	if (!UDB_WORK_RING_EMPTY(iring))
+		return (1);
+	xhci_debug_bulk_transfer(sc_udbc, iring);
+	xhci_debug_event_dequeue(sc_udbc);
+
+	return (!UDB_WORK_RING_EMPTY(iring));
+}
+static void
+udbcons_putc(struct udbcons_priv *cons, int ch)
+{
+	struct xhci_softc *sc;
+	struct xhci_debug_softc *sc_udbc;
+	struct xhci_debug_ring *oring;
+	char c;
+
+	if (cons == NULL)
+		 return;
+	if ((sc = cons->xhci) == NULL)
+		 return;
+	if (sc->sc_dbc_off == 0)
+		return;
+	if ((sc_udbc = sc->sc_udbc) == NULL)
+		return;
+
+	oring = &sc_udbc->udb_oring;
+	c = (char)(ch & 0xff);
+	if (!work_enqueue(oring, &c, sizeof(c)))
+		return;
+	xhci_debug_bulk_transfer(sc_udbc, oring);
+}
+static struct udbcons_ops udbcons0_ops = {
+	.putc = udbcons_putc,
+	.getc = udbcons_getc,
+};
+
+static tsw_outwakeup_t xhci_debug_tty_outwakeup;
+
+static struct ttydevsw xhci_debug_ttydevsw = {
+	.tsw_flags	= TF_NOPREFIX,
+	.tsw_outwakeup	= xhci_debug_tty_outwakeup,
+};
+
+static void xhci_debug_timeout(void *);
+
+int
+udbcons_init(struct xhci_softc *sc, device_t dev)
+{
+	struct udbcons_priv *cons;
+
+	device_printf(dev, "%s: enter\n", __func__);
+
+	cons = &udbcons0;
+	cons->dev = dev;
+	cons->xhci = sc;
+	cons->ops = &udbcons0_ops;
+
+	device_printf(dev, "call tty_alloc\n");
+	cons->tp = tty_alloc(&xhci_debug_ttydevsw, cons);
+	cons->polltime = 1;
+
+	device_printf(dev, "call tty_makedev\n");
+	tty_makedev(cons->tp, NULL, "%s", UDBCONS_NAME);
+	tty_init_console(cons->tp, 0);
+
+#if 1
+	device_printf(dev, "call callout_init\n");
+	callout_init(&cons->callout, 1);
+	callout_reset(&cons->callout, cons->polltime,
+	    xhci_debug_timeout, cons->tp);
+#endif
+
+	device_printf(dev, "%s: leave\n", __func__);
+
+	return (0);
+}
+
+/* xhci_debug is a console instance. */
+
+static cn_probe_t xhci_debug_cnprobe;
+static cn_init_t xhci_debug_cninit;
+static cn_term_t xhci_debug_cnterm;
+static cn_getc_t xhci_debug_cngetc;
+static cn_putc_t xhci_debug_cnputc;
+static cn_grab_t xhci_debug_cngrab;
+static cn_ungrab_t xhci_debug_cnungrab;
+
+const struct consdev_ops xhci_debug_cnops = {
+	.cn_probe	= xhci_debug_cnprobe,
+	.cn_init	= xhci_debug_cninit,
+	.cn_term	= xhci_debug_cnterm,
+	.cn_getc	= xhci_debug_cngetc,
+	.cn_putc	= xhci_debug_cnputc,
+	.cn_grab	= xhci_debug_cngrab,
+	.cn_ungrab	= xhci_debug_cnungrab,
+};
+
+CONSOLE_DRIVER(xhci_debug);
+
+#define MAX_BURST_LEN	1
+static void
+xhci_debug_tty_outwakeup(struct tty *tp)
+{
+	struct udbcons_priv *cons;
+	u_char buf[MAX_BURST_LEN];
+	int len;
+	int i;
+
+	cons = tty_softc(tp);
+	for (;;) {
+		len = ttydisc_getc(tp, buf, sizeof(buf));
+		if (len == 0)
+			break;
+		KASSERT(len == 1, ("tty error"));
+
+		for (i = 0; i < len; i++)
+			udbcons_putc(cons, buf[i]);
+	}
+}
+
+static void
+xhci_debug_timeout(void *v)
+{
+	struct udbcons_priv *cons;
+	struct tty *tp;
+	int ch;
+
+	tp = v;
+	cons = tty_softc(tp);
+
+	tty_lock(tp);
+	while ((ch = xhci_debug_cngetc(NULL)) != -1)
+		ttydisc_rint(tp, ch, 0);
+	ttydisc_rint_done(tp);
+	tty_unlock(tp);
+
+#if 0
+	if (cons->xhci != NULL)
+		device_printf(cons->dev, "%s called\n", __func__);
+#endif
+	callout_reset(&cons->callout, cons->polltime, xhci_debug_timeout, tp);
+}
+
+static void
+xhci_debug_cnprobe(struct consdev *cp)
+{
+
+	cp->cn_pri = (boothowto & RB_SERIAL) ? CN_REMOTE : CN_NORMAL;
+	sprintf(cp->cn_name, "%s", UDBCONS_NAME);
+}
+
+static void
+xhci_debug_cninit(struct consdev *cp)
+{
+}
+
+static void
+xhci_debug_cnterm(struct consdev *cp)
+{
+}
+
+/* empty */
+static void
+xhci_debug_cngrab(struct consdev *cp)
+{
+}
+
+/* empty */
+static void
+xhci_debug_cnungrab(struct consdev *cp)
+{
+}
+
+static int
+xhci_debug_cngetc(struct consdev *cp)
+{
+	int ch;
+
+	ch = udbcons_getc(&udbcons0);
+	if (ch > 0 && ch < 0xff) {
+#if defined(KDB)
+		kdb_alt_break(ch, &udbcons0.alt_break_state);
+#endif
+		return (ch);
+	}
+	return (-1);
+}
+
+static void
+xhci_debug_cnputc(struct consdev *cp, int ch)
+{
+
+	udbcons_putc(&udbcons0, ch);
+}
+#endif
